Updated: 2013-12-07 Due date:
PHP Version:
Has patch:
Complexity:
Affected Flow version: FLOW3 1.0.0
Subject: Introduced properties are not available in the reflection service during a compile run
Description

The AOP proxy builder must register each introduced property, that the other proxy builders can use the reflection service to ask for
them...

Related issues:
related to TYPO3.Flow - Bug # 51188: Doctrine does not respect AOP-injected p... New 2013-08-19
related to TYPO3.Flow - Bug # 39413: AOP: Property introduction seems to be b... Resolved 2012-07-31
related to TYPO3.Flow - Feature # 37373: Make annotation overrides / "injecti... Under Review 2012-05-21

History
#1 - 2011-08-04 09:01 - Sebastian Kurfuerst
- Target version set to 1230

#2 - 2011-09-06 14:00 - Christopher Hlubek

I think this is not only during the compile run, but also after the compilation. An introduced property will not be returned by the ReflectionService (e.g.
getPropertyNamesByTag).

#3 - 2011-10-20 01:43 - Karsten Dambekalns
- Target version deleted (1230)

#4 - 2011-10-21 13:20 - Karsten Dambekalns
- Affected Flow version set to FLOW3 1.0.0

#5 - 2013-04-16 13:01 - Alexander Berl

One could classSchema->addProperty in ProxyClassBuilder->buildProxyClass for every introduced property. However, the type information isn't
available at that point unless the docblock is parsed there also.

Wouldn't it be possible to do a whole reflectionData update for all classes with introduced properties at last? The problem I see is that the class is
already loaded with the unproxied status, so just calling the reflection won't help. So the reflection would have to be called in it's own
command/process AFTER the proxy is built.
